import pandas as pd
import numpy as np


# char-embeddings.txt to char-embeddings.csv
# char-embeddings.txt to char-embeddings-normal.csv
def txt2csv():
    dic = {}
    dic_normal = {}
    value_max = 2.42493
    value_min = -1.81528
    with open("char-embeddings.txt") as f:
        for line in f.readlines():
            spl = line[:-1].split(" ")
            if spl[1] == '':
                key = ' '
                values = spl[2:]
                pre_normal = np.array([float(i) for i in values])
                # value_max = pre_normal.max()
                # value_min = pre_normal.min()
                # Keep eight decimal places
                values_normal = np.around(((pre_normal - value_min) / (value_max - value_min)), 8).tolist()
            else:
                key = spl[0]
                values = spl[1:]
                pre_normal = np.array([float(i) for i in values])
                # value_max = pre_normal.max()
                # value_min = pre_normal.min()
                # Keep eight decimal places
                values_normal = np.around(((pre_normal - value_min) / (value_max - value_min)), 8).tolist()
            dic[key] = values
            dic_normal[key] = values_normal
    DF = pd.DataFrame(dic)
    DF.to_csv("char-embedding.csv", index=False)
    DF2 = pd.DataFrame(dic_normal)
    DF2.to_csv("char-embedding-normal.csv", index=False)


if __name__ == "__main__":
    txt2csv()
